💔 apply-rollback:
  only:
    - /^release[\/\-].+[\/\-].+/
  when: manual
  needs: ["❤ apply-rollout"]
  #  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-3.5.3.2
  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-4.0.5
  tags:
    - docker-itsd
  stage: rollback
  script: 
    # - export KUBECONFIG=$(env | grep PROD_KUBECONFIG | awk -F '=' '{print $2}')
    - cd kubernetes
    - export env=prod
    - |
      if [ -z $PROD_SITE ];
        then export LIST=PROD_KUBECONFIG;
      else
        for item in $(echo $PROD_SITE | sed "s/,/ /g")
        do
          if [ $item == "default" ];
          then
            export LIST=${LIST}PROD_KUBECONFIG,
          else
            export LIST=${LIST}PROD_KUBECONFIG_${item},
          fi;
        done;
        export LIST=${LIST::-1}
      fi;
    - echo "Cluster List ${LIST}"
    - |
      for cluster in $(echo $LIST | sed "s/,/ /g")
      do
        echo "Deploying ${cluster}";
        export KUBECONFIG=$(eval echo $"${cluster}");
        echo $KUBECONFIG;
        doc_count=$(yq -d'*' r output-${env}.yaml "kind" | wc -l);
        count=0;
        while [ $count -le $(($doc_count -1)) ]; do
          kind=$(yq -d"$count" r output-${env}.yaml "kind");
          if [ $kind == "Deployment" ]; then
            rs_name=$(yq -d"$count" r output-${env}.yaml metadata.name);
            kubectl rollout undo deploy/${rs_name};
          elif [ $kind == "StatefulSet" ]; then
            rs_name=$(yq -d"$count" r output-${env}.yaml metadata.name);
            kubectl rollout undo sts/${rs_name};
          fi;
          count=$(( $count + 1 ));
        done;
      done;
    # - |
    #   doc_count=$(yq -d'*' r output-${env}.yaml "kind" | wc -l);
    #   count=0;
    #   while [ $count -le $(($doc_count -1)) ]; do
    #     kind=$(yq -d"$count" r output-${env}.yaml "kind");
    #     if [ $kind == "Deployment" ]; then
    #       rs_name=$(yq -d"$count" r output-${env}.yaml metadata.name);
    #       kubectl rollout undo deploy/${rs_name};
    #     elif [ $kind == "StatefulSet" ]; then
    #       rs_name=$(yq -d"$count" r output-${env}.yaml metadata.name);
    #       kubectl rollout undo sts/${rs_name};
    #     fi;
    #     count=$(( $count + 1 ));
    #   done;
  after_script:
    - curl $BISMARCK_HOST/completed/$CI_PIPELINE_ID/rollback/$GITLAB_USER_EMAIL


close-cc:
  only:
    - /^release[\/\-].+[\/\-].+/
  when: manual
  needs: ["❤ apply-rollout"]
  variables:
    GIT_STRATEGY: none
    #  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-3.5.3.2
  image: reghbpr01.dc1.true.th/tools/kustomize-docker:v-4.0.5
  tags:
    - docker-itsd
  stage: close-cc
  script: 
    - curl $BISMARCK_HOST/completed/$CI_PIPELINE_ID/close/$GITLAB_USER_EMAIL